   program


   map
      CarlBarnes
      GordonSmith
      BriceShagane
   end


   code
   carlbarnes()
   BriceShagane()
   GordonSmith()

!******************* Carl Barnes ********************

CarlBarnes     procedure
 
Window WINDOW('Modified by Carl Barnes'),AT(,,196,152)|
    ,FONT('Times New Roman'),TIMER(10),GRAY,SYSTEM,center
       SHEET,AT(28,24,139,100),USE(?Sheet),SPREAD
         TAB('Tab 1'),USE(?Tab1)
         END
         TAB('Tab 2'),USE(?Tab2)
         END
         TAB('Tab 3'),USE(?Tab3)
         END
         TAB('Tab 4'),USE(?Tab4)
         END
       END
     END

side    LONG(1)
tab     LONG(1)
tabIncr LONG(1)
NumTabs LONG
   code
   open(window)
   !do CheckProps
   NumTabs = ?Sheet{PROP:NumTabs}
   accept
      case event()
      of event:timer
         !End of tabs for one side?
         IF ~INRANGE(Tab+TabIncr, 1, NumTabs )

            !move to next side
            side = side % 4 + 1

            !Adjust tabs for specific side
            EXECUTE side                                
                TabIncr = 1
                Tab = 1
                TabIncr = -1
                Tab = NumTabs
            END

            ?sheet{ CHOOSE(Side,prop:above,prop:right,|
               prop:below,prop:left) }=1
            ?sheet{prop:angle} = CHOOSE(Side,0,2700,1800,900)

            !other ways to code:
            !   CASE side                                   
            !   OF 1 ; ?sheet{prop:above} = 1  ; TabIncr = 1
            !   OF 2 ; ?sheet{prop:right} = 1  ; Tab = 1
            !   OF 3 ; ?sheet{prop:below} = 1  ; TabIncr = -1
            !   OF 4 ; ?sheet{prop:left}  = 1  ; Tab = NumTabs
            !   END
            !
            !   1=0, 2=2700, 3=1800, 4=900
            !  ?sheet{prop:angle} = (5 - Side) * 900  % 3600                   

         ELSE
            Tab += TabIncr
         END
         SELECT(?Sheet, Tab)
         DISPLAY

!      of event:timer
!         Vary the angle to see what it looks like
!         ?sheet{prop:angle} = ang# * 100
!         ang# = ang# % 36 + 1
!         display

      end
   end
   close(window)

CheckProps   routine
    DATA
pq      queue,pre(pq)
prop        long
value       string(32)
        end
pidx            long
comparevalue    like(pq.value)

    CODE
    free(pq)
    !save all the properties
    loop pidx = 07a00h to 07effh        
         clear(pq)
         pq.prop  = pidx
         pq.value = ?sheet{ pidx }
         IF  pq.value
            ADD( pq )
         END
    end
    SORT(pq, pq.prop)

    !change the property that is a mystery
    ?sheet{prop:upsidedown} = 1         

    !now see what changed
    loop pidx = 07a00h to 07cffh        
         clear(pq)
         pq.prop  = pidx
         GET(pq, pq.prop)
         comparevalue = ?sheet{ pidx }
         IF pq.value <> comparevalue
            message(pidx & '|old=' & clip(pq.value) |
               & '|new=' & CLIP(comparevalue) )
         END
    end

    ! 31977 (7CE9h) changed from 0 to 1800,



BriceShagane    procedure

Window WINDOW('Modified by Brice Schagane'),AT(,,196,152),FONT('Times New Roman',,,,CHARSET:ANSI), |
         TIMER(10),GRAY,center
       SHEET,AT(28,24,139,100),USE(?Sheet),SPREAD
         TAB('Tab 1'),USE(?Tab1)
         END
         TAB('Tab 2'),USE(?Tab2)
         END
         TAB('Tab 3'),USE(?Tab3)
         END
         TAB('Tab 4'),USE(?Tab4)
         END
       END
     END

count long(1)
tab   short(1)

   code
   open(window)
   display()
   accept
      case event()
      of event:timer
         case count
         of 1
            ?sheet{prop:above} = 1
            ?sheet{prop:upsidedown} = 0
         of 5
            ?sheet{prop:right} = 1
            ?sheet{prop:down} = 1
         of 9
            ?sheet{prop:upsidedown} = 1
            ?sheet{prop:below} = 1
         of 13
            ?sheet{prop:left} = 1
            ?sheet{prop:up} = 1
         end
         if count <= 9
            tab = count - BAND(count-1, 100b)
         else
            tab = BXOR(count, 11111b) - 14 - |
              BAND(BXOR(count, 11111b)-15, 100b)
         end
         execute (tab)
            select(?tab1)
            select(?tab2)
            select(?tab3)
            select(?tab4)
         end
         count += 1 - BAND(count, 10000b)
      end
   end
   close(window)



GordonSmith    procedure

Window WINDOW('Modified by Gordon Smith'),AT(,,196,152),FONT('Times New Roman',,,,CHARSET:ANSI), |
         GRAY,TIMER(10),center
       SHEET,AT(28,24,139,100),USE(?Sheet),SPREAD
         TAB('Tab 1'),USE(?Tab1)
         END
         TAB('Tab 2'),USE(?Tab2)
         END
         TAB('Tab 3'),USE(?Tab3)
         END
         TAB('Tab 4'),USE(?Tab4)
         END
       END
     END

count byte(1)

   code
   open(window)
   accept
     if event() = event:timer
       select(choose(choose(count > 8, 4 - (count - 1) % 4, (count - 1) % 4 + 1), ?Tab1, ?Tab2, ?Tab3, ?Tab4))
       ?sheet{choose(int((count - 1) / 4) + 1, prop:above, prop:right, prop:below, prop:left)} = true
       ?sheet{choose(int((count - 1) / 4) + 1, prop:angle, prop:down, prop:upsidedown, prop:up)} = choose(int((count - 1) / 4))
       count = (count % 16) + 1
     end
   end
   close(window)

